import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JTextField;
import java.awt.Color;
import java.awt.Font;
import javax.swing.SwingConstants;

import javax.swing.Timer;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


import org.usb4java.Context;
import org.usb4java.Device;
import org.usb4java.DeviceDescriptor;
import org.usb4java.DeviceList;
import org.usb4java.LibUsb;
import org.usb4java.LibUsbException;

import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JScrollBar;
import java.awt.SystemColor;
import java.awt.event.AdjustmentListener;
import java.awt.event.AdjustmentEvent;


public class JFrame1 {

	public boolean vCzyUSBASP;
	public Device USBASPDevice;
	public int vtimer=100;
	
	public Byte USBASP_I2C_BITBANG_ON = (byte) 124;
	public Byte USBASP_I2C_BITBANG_OFF = (byte) 125;	
	public Byte USBASP_I2C_SDA_HI = (byte) 126;	
	public Byte USBASP_I2C_SDA_LO = (byte) 127;
	public Byte USBASP_I2C_SCL_HI = (byte) 128;
	public Byte USBASP_I2C_SCL_LO = (byte) 129;
	
	private JFrame frame;
	private JTextField txtCzyJestUsbasp;
	private JTextField textResult;

	
	//TIMER 1s
	Timer  timer=new Timer(1000,new ActionListener(){
        public void actionPerformed(ActionEvent e)
    {		vCzyUSBASP=znajdzUSBASP();
        	if (vCzyUSBASP==true) {
        		txtCzyJestUsbasp.setBackground(Color.GREEN);
        		txtCzyJestUsbasp.setText("ATBUSBASP wykryty");
        	}else {
        		txtCzyJestUsbasp.setBackground(Color.PINK);
        		txtCzyJestUsbasp.setText("brak ATBUSBASP");
        	}
        	
    }
    });
	//TIMER LED
	Timer  timerLED=new Timer(vtimer,new ActionListener(){
        public void actionPerformed(ActionEvent e)
    {	
        	if ( textResult.getBackground()==SystemColor.menu ) 
        	{	sendCMD(USBASP_I2C_SCL_HI);
				sendCMD(USBASP_I2C_SDA_LO);
        		textResult.setBackground(Color.GREEN);
        	}else 
        	{	
        		textResult.setBackground(SystemColor.menu);
        		sendCMD(USBASP_I2C_SCL_LO);
				sendCMD(USBASP_I2C_SDA_HI);
        	}	
    }
    });
	
	
	/**
	 * Launch the application.
	 */
	
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					JFrame1 window = new JFrame1();
					window.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	
	public JFrame1() {
		
		initialize();
		
		timer.start();
}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		
		frame = new JFrame();
		frame.setBounds(100, 100, 450, 300);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().setLayout(null);
		
		JLabel lblPinakaV = new JLabel("tester API USBASP in JAVA");
		lblPinakaV.setHorizontalAlignment(SwingConstants.RIGHT);
		lblPinakaV.setBounds(268, 0, 156, 14);
		frame.getContentPane().add(lblPinakaV);
		
		txtCzyJestUsbasp = new JTextField();
		txtCzyJestUsbasp.setText("CZY JEST USBASP?");
		txtCzyJestUsbasp.setHorizontalAlignment(SwingConstants.CENTER);
		txtCzyJestUsbasp.setFont(new Font("Tahoma", Font.BOLD, 12));
		txtCzyJestUsbasp.setEditable(false);
		txtCzyJestUsbasp.setColumns(10);
		txtCzyJestUsbasp.setBackground(Color.PINK);
		txtCzyJestUsbasp.setBounds(278, 227, 156, 35);
		frame.getContentPane().add(txtCzyJestUsbasp);
	
		JButton btnstart = new JButton("start");
		btnstart.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				timerLED.start();
				sendCMD(USBASP_I2C_BITBANG_ON);
			}
		});
		btnstart.setBounds(101, 71, 89, 23);
		frame.getContentPane().add(btnstart);
		
		JButton btnstop = new JButton("stop");
		btnstop.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				timerLED.stop();
				sendCMD(USBASP_I2C_BITBANG_OFF);
				textResult.setBackground(SystemColor.menu);
			}
		});
		btnstop.setBounds(230, 71, 89, 23);
		frame.getContentPane().add(btnstop);
		

		
		textResult = new JTextField();
		textResult.setText("1");
		textResult.setHorizontalAlignment(SwingConstants.CENTER);
		textResult.setFont(new Font("Tahoma", Font.BOLD | Font.ITALIC, 11));
		textResult.setEditable(false);
		textResult.setColumns(10);
		textResult.setBackground(SystemColor.menu);
		textResult.setBounds(0, 132, 49, 17);
		frame.getContentPane().add(textResult);
		
		JScrollBar scrollBar = new JScrollBar();
		scrollBar.addAdjustmentListener(new AdjustmentListener() {
			public void adjustmentValueChanged(AdjustmentEvent e) {
				vtimer =e.getValue(); 
				timerLED.setDelay(vtimer);
				textResult.setText(Integer.toString(vtimer));
				
			}
		});

		scrollBar.setValue(1000);
		scrollBar.setOrientation(JScrollBar.HORIZONTAL);
		scrollBar.setMinimum(1);
		scrollBar.setMaximum(5000);
		scrollBar.setBlockIncrement(1);
		scrollBar.setBackground(Color.GRAY);
		scrollBar.setBounds(48, 132, 386, 17);
		frame.getContentPane().add(scrollBar);

	}
	

	public boolean znajdzUSBASP()
	{
		int result;  
		
		Context context = new Context();
		result = LibUsb.init(context);
		if (result != LibUsb.SUCCESS) throw new LibUsbException("Unable to initialize libusb.", result);


	    // Read the USB device list
	    DeviceList list = new DeviceList();
	    result = LibUsb.getDeviceList(null, list);
	    if (result < 0) throw new LibUsbException("Unable to get device list", result);

	    try
	    {
	        // Iterate over all devices and scan for the right one
	        for (Device device: list)
	        {
	            DeviceDescriptor descriptor = new DeviceDescriptor();
	            result = LibUsb.getDeviceDescriptor(device, descriptor);
	            if (result != LibUsb.SUCCESS) throw new LibUsbException("Unable to read device descriptor", result);
	            if (descriptor.idVendor() == 5824 && descriptor.idProduct() == 1500) {
	            	USBASPDevice = device;
	            //	LibUsb.exit(context);
	            	return true;
	            }
	        }
	    }
	    finally {
	        // Ensure the allocated device list is freed
	        LibUsb.freeDeviceList(list, false);
		    
	        if (USBASPDevice != null) {
		        // Device found
		        LibUsb.refDevice(USBASPDevice);
		    }
	    }

	    // Device not found
	    USBASPDevice = null;
	    return false;
	}

    public void sendCMD(byte request) {
        int timeout = 0;
        DeviceHandle handle = new DeviceHandle();
        int result = LibUsb.open(USBASPDevice, handle);
        if (result != LibUsb.SUCCESS) throw new LibUsbException("Unable to open USB device", result);
        try
        {
            // Use device handle here
            ByteBuffer buffer = ByteBuffer.allocateDirect(8);
            //buffer.put(new byte[] { 1, 2, 3, 4, 5, 6, 7, 8 });
            int transfered = LibUsb.controlTransfer(handle, 
                (byte) 0x40,
                (byte) request, (short) 0, (short) 0, buffer, timeout);
            //if (transfered < 0) throw new LibUsbException("Control transfer failed", transfered);

        }
        finally
        {
            LibUsb.close(handle);
        }
    }


}
